package org.gcube.common.authorization.client.proxy;

import java.util.List;

import org.gcube.common.authorization.client.exceptions.ObjectNotFound;
import org.gcube.common.authorization.library.AuthorizationEntry;
import org.gcube.common.authorization.library.enpoints.AuthorizationEndpoint;

public interface AuthorizationProxy {

	AuthorizationEndpoint getEndpoint();
	
	void setEndpoint(AuthorizationEndpoint endpoint);
	
	@Deprecated
	String generate(String userName, List<String> roles) throws Exception;
	
	AuthorizationEntry get(String token) throws ObjectNotFound, Exception;

	String generate(String clientId, String context, List<String> roles)
			throws Exception;

	/*
	BannedService deny(String userName, String serviceClass, String serviceName) throws Exception;

	void allow(String userName, String serviceClass, String serviceName) throws Exception;
	
	List<BannedService> getBannedServices(String userName) throws Exception;*/
}
